var alphabet = ["_/","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"] //for the sake of Internet Explorer this must be an array not a string
var total_assignments = 0; //total number of class assignments
var total_students = 0; //total number of students in class

var data = new Array();
var info = new Array();
var backup = "";
info[0] = ["Untitled","Teacher Name","neversaved"]
info[1] = ["1/1/08","T1","Test 1","T"]

window.onload = function()
{
  notify(); //clear notice about javascript required

  /*globalStorage['localhost'].lastsaved = "testing"*/
  
  if (document.cookie) {
    importData(readCookie("Grade_Book"));
  }
  
  if ((output = xpcomFileRead(info[0][2]))) {
	  importData(output);
  }
  
  if (data.length <= 1) notify("Try adding new students first");
  /*
  if(globalStorage.gradebook) {
    alert(globalStorage.gradebook);
  }
  */
  
  // onclick events for buttons above table
  el("gradebook").onsubmit = submitForm;
  el("save_as_button").onclick = saveAs; //fileSummaryDialog;
  el("open_button").onclick = openFile;
  el("undo_button").onclick = undo;
  el("redo_button").onclick = redo;
  
  // onchange events for input boxes within table
  var table_inputs = el("gradebook").getElementsByTagName("input");
  for (var i=0; i < table_inputs.length; i++) {
    if (table_inputs[i].type == "text") table_inputs[i].onchange = submitForm;
  }
  //document.gradebook.onchange = submitForm;
  //[will need to add onchange events to 
  
  
  // onclick events for buttons below table
  el("new_assignment_button").onclick = newAssignmentDialog;
  el("new_student_button").onclick = addStudent;
  el("delete_students_button").onclick = deleteStudents;
  
  //set form elements
	el("sourcecode").value = packageArrays();
  el("undo_button").disabled = true;
  
  document.onkeypress = keyBindings;
  //el("gradebook").onkeypress = keyBindings;
}

function keyBindings(e)
{
  // Get key
  var keynum;
  
  if (window.event) // IE
    keynum = e.keyCode;
  else if (e.which) // Netscape/Firefox/Opera
    keynum = e.which;
  
  var keychar = String.fromCharCode(keynum)
  //notify(keynum+" "+keychar+" "+e.keyCode+" "+e.ctrlKey);
  
  // Key bindings
  if (keychar=="s" && e.ctrlKey) {
    submitForm();
    notify("File saved");
    return false;
  } else if (keychar=="o" && e.ctrlKey) {
    openFile();
    return false;
  } else {
    return true;
  }
}

//adds onchange events for all input boxes within main table
//temp solution until onchange added individually to each new element on addStudent or addAssignment
function updateOnChangeEvents() {
  var table_inputs = el("gradebook").getElementsByTagName("input");
  for (var i=0; i < table_inputs.length; i++) {
    if (table_inputs[i].type == "text") table_inputs[i].onchange = submitForm;
  }
}


function test() {
  alert(this.id+"\n"+this.type)
  }

function el(id) 
{ 
 if (document.getElementById) { 
   return document.getElementById(id); 
 } else if (window[id]) { 
   return window[id]; }
 return null;
}

//displays messages to user (such as error messages)
function notify(message,permanent)
{
  if (message) {
    el("notice").style.visibility = "visible";
    el("notice").innerHTML = message;
    //if (!permanent) setTimeout("el('notice').style.visibility = 'hidden';",9000);
  } else {
    el("notice").style.visibility = "hidden";
  }
}

function submitForm()
{ 
  updateArrays();
  updatePercentages();
  
  return false; //prevents HTML from reloading
}

//Calculates percentages for each student and updates display
function updatePercentages()
{
  for (j = 1; j <= total_students; j++) {
    var points = 0; //stores running point total for student grade
    var points_Max = 0; //store running point total for student max grade
    var assignments = new Array(); //stores grades for one student's assignments
    assignments[0] = el("Student_"+j).value; //stores the sudents name to assignments[0]
    
    for (i = 1; i <= total_assignments; i++) {
      if (el(alphabet[i]+j).value != "EXC") {
        points += (el(alphabet[i]+j).value == "") ? 0 : eval(el(alphabet[i]+j).value);
        points_Max += eval(el(alphabet[i]+"_Max").value);
        
        //Mark scores above max or empty scores in student points
        if (eval(data[j][i]) > eval(data[0][i])) { 
          el(alphabet[i]+j).className = "extra_credit";
          notify('Star (<img src="./images/star.png" alt="Extra Credit" />) indicates a score higher than max');
        } else if (data[j][i] == "") {
          el(alphabet[i]+j).className = "error"; 
          notify('Red mark (<img src="./images/error.png" alt="Error" />) indicates a blank score');
        } else {
          el(alphabet[i]+j).className = "";
        }
        
        
        // Display errors in assignment max points (no score entered)
        if (data[0][i] == "") el(alphabet[i]+"_Max").className = "error";
        else el(alphabet[i]+"_Max").className = "";
      }
    }
    
    var percent = (points_Max == 0) ? 100 : points / points_Max * 100;
    el("Percent_"+j).innerHTML = Math.round(percent*100)/100 + "%"; //parseInt(percent);
    
  }
}

function packageArrays()
{
  var save1 = new Array();
  var save2 = new Array();
  for (i=0; i < data.length; i++) {
    save1[i] = data[i].join("|");
  }
  for (i=0; i < info.length; i++) {
    save2[i] = info[i].join("|");
  }
  return save1.join("\n")+"\n***"+save2.join("\n");
}

function processFile(file)
{
  backupSave(); //Make backup copy in case undo is needed
  
  info = [0] //initialize
  data = [0] //initialize
  file += "";
  var split0 = file.split("\n***");
  var split1 = split0[0].split("\n");
  var split2 = split0[1].split("\n");
  for (i=0; i < split1.length; i++) {
    data[i] = split1[i].split("|");
  }
  for (i=0; i < split2.length; i++) {
    info[i] = split2[i].split("|");
  }
}

function updateArrays()
{
  //Make backup copy of data and info arrays (in case undo is needed)
  backupSave();
  
  // Max points for each assignment
  var assignments = new Array();
  assignments[0] = " ";
  data = [0] //initialize
  
  for (i = 1; i <= total_assignments; i++) {
    assignments[i] = el(alphabet[i]+"_Max").value;
  }
  data[0] = assignments;
  
  // Student points for each assignment
  for (j = 1; j <= total_students; j++) {
    var assignments = new Array(); //stores grades for one student's assignments
    assignments[0] = el("Student_"+j).value; //stores the sudents name to assignments[0]
    
    for (i = 1; i <= total_assignments; i++) {
      assignments[i] = el(alphabet[i]+j).value;
    }
  
    data[j] = assignments;
  }

  // Assignment titles
  for (i = 1; i <= total_assignments; i++) {
    info[i][1] = el(alphabet[i]).value;
  }
  
  // Save changes
  save()
}

function save()
{
  notify() //clear notifications;
  
  el("sourcecode").value = packageArrays();
  updateCookie(packageArrays());
  
  // Local file save
  xpcomFileWrite(info[0][2], packageArrays());

  //globalStorage.gradebook = save.join("\n");
}

// Make backup copy in case undo is needed
function backupSave()
{
  backup = packageArrays();
  el("undo_button").disabled = false;
  el("redo_button").disabled = true;
}

function undo()
{
  importData(backup);
  save();
  el("undo_button").disabled = true;
  el("redo_button").disabled = false;
}

function redo()
{
  importData(backup);
  save();
  el("redo_button").disabled = true;
  el("undo_button").disabled = false;
}

//var save = new Array();
/*
function exportData()
{
  // Max points for each assignment
  var assignments = new Array();
  assignments[0] = " ";
  data = [0] //initialize
  
  for (i = 1; i <= total_assignments; i++) {
    assignments[i] = el(alphabet[i]+"_Max").value;
  }
  data[0] = assignments;
  save[0] = assignments.join("|");
  
  // Student points for each assignment
  for (j = 1; j <= total_students; j++) {
    var assignments = new Array(); //stores grades for one student's assignments
    assignments[0] = el("Student_"+j).value; //stores the sudents name to assignments[0]
    
    for (i = 1; i <= total_assignments; i++) {
      assignments[i] = el(alphabet[i]+j).value;
    }
    
    data[j] = assignments;
    save[j] = assignments.join("|");
  }

  // Assignment titles
  var assignments = new Array();
  assignments[0] = "zzTitles";
  
  for (i = 1; i <= total_assignments; i++) {
    assignments[i] = el(alphabet[i]).value;
  }
  data[total_students+1] = assignments;
  save[total_students+1] = assignments.join("|");
  
  
  el("file").value = save.join("\n");
  updateCookie(save.join("\n"));
  //globalStorage.gradebook = save.join("\n");
}
*/

function importData(file)
{
  if (file=="") { file = "Max|100\nJoe|92\n***Untitled|Teacher Name|C:\\Grade Book\\Untitled.txt\n1/1/08|T1|Test 1|T"; }
  if (file) {
    // Process file
    processFile(file);
  }
  
  // Add new rows to table if needed
  while (total_students < data.length-1) {
    total_students += 1;
    addRow();
  }
  //Subtract extra rows if needed
  while (total_students > data.length-1) {
    total_students += -1;
    deleteRow();
  }
  
  // Add new columns to table if needed
  while (total_assignments < info.length-1) {
    total_assignments += 1;
    addCol();
  }
  while (total_assignments > info.length-1) {
    total_assignments += -1
    deleteCol();
  }
  

  // Update max points display
  for (i = 1; i <= total_assignments; i++) {
    el(alphabet[i]+"_Max").value = data[0][i];
  }
  
  // Update student points for each assignment
  for (j = 1; j <= total_students; j++) {
    el("Student_"+j).value = data[j][0]; //stores the sudents name to assignments[0]
    for (i = 1; i <= total_assignments; i++) {
      el(alphabet[i]+j).value = data[j][i]
    }
  }
  
  //Update titles for each assignment
  for (i = 1; i <= total_assignments; i++) {
    el(alphabet[i]).value = info[i][1];
  }
  
  //Caluculations percent for each student and update display
  updatePercentages();
}
    
function addStudent()
{ 
  total_students += 1;
  addRow();
  updateArrays();
  save();
  updatePercentages();
  updateOnChangeEvents();
  el("Student_"+total_students).focus();
  el("Student_"+total_students).select();
}

function addRow()
{  
  //create new row at end of table
  var new_row = el("gradebooktable").insertRow(-1);
  
  //create student name cell
  var header_cell = document.createElement('th');
  new_row.appendChild(header_cell);
  header_cell.innerHTML = '<input type="checkbox" id="Select_' + total_students
          + '" /><input type="text" value="New Student" id="Student_' + total_students + '" size="15" tabindex="20" />\n';
  
  //create percent cell
  var new_cell = new_row.insertCell(1);
  new_cell.className = "noedit";
  new_cell.innerHTML = '<span id="Percent_' + total_students + '">%</span>\n';
  
  //create remaining data cells
  for (i = 1; i <= total_assignments; i++) {
    var new_cell = new_row.insertCell(i+1);
    new_cell.innerHTML = '<input type="text" value="" id="' + alphabet[i] + total_students + '" size="3" tabindex="'
           + 10*(i+2) + '" />\n';
  }
}

function deleteStudents()
{
  backupSave();

  var none_checked = true; //flag
  
  for(i = total_students; i >= 1; i--) {
    if (el("Select_"+i).checked) {
      el("Select_"+i).checked = false;
      total_students -= 1;
      data.splice(i,1);
      deleteRow();
      none_checked = false;
    }
  }
  
  if (none_checked) {
    notify("No students marked for deletion.\n\nUse checkboxes next to student name to mark for deletion.");
  } else {
    save();
    importData();
  }
}

function deleteRow()
{
  el("gradebooktable").deleteRow(-1);
}

function newAssignmentDialog()
{
  var date = new Date();
  var year = date.getYear()+"";
  el("date").value = (date.getMonth()+1) + "/" + date.getDate() + "/" + year.substring(year.length-2,year.length);
  
  el("new_assignment_button").disabled = true;
  el("assignment").style.display = "block";
  el("assignment").onsubmit = addAssignment;
  el("abbr_title").focus();
  el("abbr_title").select();
}

function addAssignment()
{
  total_assignments += 1;
  
  backupSave();
  var title_info = new Array();
  title_info[0] = el("date").value;
  title_info[1] = el("abbr_title").value;
  title_info[2] = el("full_title").value;
  title_info[3] = el("type").value;
  info[total_assignments] = title_info;
  for (i = 0; i <= total_students; i++) {
    data[i].push("");
  }
  save();

  addCol()
  importData();
  updateOnChangeEvents();
  
  el("new_assignment_button").disabled = false;
  el("assignment").style.display = "none"; 
  el(alphabet[total_assignments]+"_Max").focus();
  el(alphabet[total_assignments]+"_Max").select();
  
  return false; //prevents entire page from reloading
}

function addCol()
{
  //create assignment title cell
  var header_cell = document.createElement('th');
  el("gradebooktable").rows[0].appendChild(header_cell);
  header_cell.innerHTML = '<input type="text" value="' + info[total_assignments][1] + '" title="'
          + info[total_assignments][2] + '" id="' + alphabet[total_assignments] 
          + '" size="3" tabindex="' + 10*(total_assignments+2) + '" />\n';
  
  //create max points cell
  var new_cell = el("gradebooktable").rows[1].insertCell(total_assignments+1);
  new_cell.innerHTML = '<input type="text" value="100" id="' + alphabet[total_assignments] 
          + '_Max" size="3" tabindex="' + 10*(total_assignments+2) + '" />\n';
  
  //create data cells for each student
  for (i = 1; i <= total_students; i++) {
    var new_cell = el("gradebooktable").rows[i+1].insertCell(total_assignments+1);
    new_cell.innerHTML = '<input type="text" value="" id="' + alphabet[total_assignments] + i
          +'" size="3" tabindex="' + 10*(total_assignments+2) + '" />\n';;
  }
}

function deleteAssignment()
{
  deleteCol();
}

function deleteCol()
{
  //delete last cell from each row
  for (i = 0; i <= total_students+1; i++) {
    el("gradebooktable").rows[i].deleteCell(-1);
  }
}

function fullIndividualReports()
{
  var newHTML  = '<?xml version="1.0" encoding="UTF-8"?>\n'
          + '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"\n'
          + '   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n'
          + '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" >\n'
          + '<head><title>' + info[0][1] + ': ' + info[0][0] + '</title>' // Teacher and class name
          + '<style type="text/css">td {padding-right:4em} th {text-align:left}</style></head>\n'
          + '<body onload="window.print()">\n';
  
  for (j = 1; j <= total_students; j++) {
  
    // Add student name, and table headings
    newHTML  += "\n<h1>" + data[j][0] + "</h1>\n" // Student name
          + '<table><tr><th>Title</th><th>Type</th><th>Date</th><th>Grade</th></tr>\n';
    
    // Add student data for every assignment 
    for (i = 1; i <= total_assignments; i++) {
      newHTML += "<tr>\n<td>" + info[i][2] //full title of assignment
          + "</td><td>" + info[i][3] //type
          + "</td><td>" + info[i][0] //date
          + "</td><td>" + data[j][i] //grade
          + " / " + data[0][i] + "</td></tr>\n"; //max points
    }
    
    // Calculate letter grade
    var percent = el("Percent_"+j).innerHTML;
    percent = percent.substring(0,percent.length-1);
    var letter = getLetterGrade(percent);
    
    // Add overall grade
    newHTML += '</table>\n\n'
          + '<p style="page-break-after:always"><strong>Overall Grade: ' + percent + '% ' + letter + '</strong></p>\n\n';
  }
  newHTML += "</body>\n</html>";
  
  document.writeln(newHTML);
  document.close();
}

function getLetterGrade(percent)
{
  var grade; 
  
  if (percent >= 95) grade = "A"
  else if (percent >= 90) grade = "A-"
  else if (percent >= 87) grade = "B+"
  else if (percent >= 83) grade = "B"
  else if (percent >= 80) grade = "B-"
  else if (percent >= 77) grade = "C+"
  else if (percent >= 73) grade = "C"
  else if (percent >= 70) grade = "C-"
  else if (percent >= 67) grade = "D+"
  else if (percent >= 63) grade = "D"
  else if (percent >= 60) grade = "D-"
  else grade = "F";
  
  return grade;
}

/*function openFileDialog()
{/*
  el("open_button").disabled = true;
  el("open").style.display = "block";
  el("open").onsubmit = openFile;
  el("open_file").focus();
  el("open_file").select();
  
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
  
  //code snippet from http://developer.mozilla.org/en/docs/nsIFilePicker#Example
  const nsIFilePicker = Components.interfaces.nsIFilePicker;

  var fp = Components.classes["@mozilla.org/filepicker;1"]
  	           .createInstance(nsIFilePicker);
  fp.init(window, "Open File", nsIFilePicker.modeOpen);
  fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterText);

  var rv = fp.show();
  if (rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) {
    var file = fp.file;alert(file);
    // Get the path as string. Note that you usually won't 
    // need to work with the string paths.
    var path = fp.file.path;alert(path);
    // work with returned nsILocalFile...
  }
}

function openFile() 
{//alert(el("open_file").value +"\n"+xpcomFileRead(el("open_file").value));
  if (xpcomFileRead(el("open_file").value)) {
    importData(xpcomFileRead(el("open_file").value));
  } else {
    notify("No file selected",false);
  }
  
  el("open_button").disabled = false;
  el("open").style.display = "none";
  
  return false; //prevents entire page from reloading
}*/

function fileSummaryDialog()
{
  backupSave(); //make backup of data and info arrays in case of undo
  
  el("class_title").value = info[0][0];
  el("teacher").value = info[0][1];
  el("file_save_location").value = info[0][2];
  el("save_as_button").disabled = true;
  el("file_summary").style.display = "block";
  el("file_summary").onsubmit = saveFileSummary;
  el("class_title").focus();
  el("class_title").select();
}
function saveFileSummary()
{
  info[0] = [el('class_title').value , el('teacher').value, el('file_save_location').value];
  save();
  el("save_as_button").disabled = false;
  el("file_summary").style.display = "none";
    
  return false; //prevents entire page from reloading
}

function showSource()
{
  el("sourcecode_form").style.display = "block";
  el("show_source").innerHTML = "Hide source code";
  el("show_source").href = "javascript:hideSource();";
}
function hideSource()
{
  el("sourcecode_form").style.display = "none";
  el("show_source").innerHTML = "Show source code";
  el("show_source").href = "javascript:showSource();";
}